//spammerRocketLauncher.cs

//muzzle flash effects
datablock ParticleData(spammerRocketLauncherFlashParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = 1.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 1500;
	lifetimeVarianceMS   = 150;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.4 0.0 0.9";
	colors[1]     = "0.9 0.5 0.0 0.0";
	sizes[0]      = 0.25;
	sizes[1]      = 0.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(spammerRocketLauncherFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 10.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "spammerRocketLauncherFlashParticle";

   uiName = "";
};

datablock ParticleData(spammerRocketLauncherSmokeParticle)
{
	dragCoefficient      = 5;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 300;
	lifetimeVarianceMS   = 250;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;

   colors[0]     = "0.5 0.5 0.5 0.0";
	colors[1]     = "0.5 0.5 0.5 0.9";
	colors[2]     = "0.5 0.5 0.5 0.0";

	sizes[0]      = 0.25;
   sizes[1]      = 1.0;
	sizes[2]      = 1.75;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(spammerRocketLauncherSmokeEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 10.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 25;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "spammerRocketLauncherSmokeParticle";

   uiName = "";
};


//bullet trail effects
datablock ParticleData(spammerRocketTrailParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.15;
	constantAcceleration = 0.0;
	lifetimeMS           = 1000;
	lifetimeVarianceMS   = 805;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -150.0;
	spinRandomMax		= 150.0;
	colors[0]     = "1.0 1.0 0.0 0.4";
	colors[1]     = "1.0 0.2 0.0 0.5";
   colors[2]     = "0.20 0.20 0.20 0.3";
   colors[3]     = "0.0 0.0 0.0 0.0";

	sizes[0]      = 0.25;
	sizes[1]      = 0.85;
   sizes[2]      = 0.35;
 	sizes[3]      = 0.05;

   times[0] = 0.0;
   times[1] = 0.05;
   times[2] = 0.3;
   times[3] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(spammerRocketTrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 1;
   ejectionVelocity = 0.25;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "spammerRocketTrailParticle";

   uiName = "";
};


datablock ParticleData(spammerrocketExplosionParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.9 0.6 0.9";
	colors[1]     = "0.9 0.5 0.6 0.0";
	sizes[0]      = 10.0;
	sizes[1]      = 15.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(spammerrocketExplosionEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 1.0;
   ejectionOffset   = 3.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "spammerRocketExplosionParticle";

   uiName = "";
   emitterNode = TenthEmitterNode;
};


datablock ParticleData(spammerrocketExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 40;
	lifetimeVarianceMS   = 10;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 0.5 0.2 0.5";
	colors[1]     = "0.9 0.0 0.0 0.0";
	sizes[0]      = 8;
	sizes[1]      = 13;

	useInvAlpha = false;
};
datablock ParticleEmitterData(spammerRocketExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 3.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "spammerRocketExplosionRingParticle";

   uiName = "";
};

datablock ExplosionData(spammerRocketExplosion)
{
   //explosionShape = "";
   explosionShape = "Add-Ons/Weapon_Rocket_Launcher/explosionSphere1.dts";
	soundProfile = spammerRocketExplodeSound;

   lifeTimeMS = 150;

   particleEmitter = spammerRocketExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.1;

   emitter[0] = spammerRocketExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "0.5 0.5 0.5";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 5.0;

   // Dynamic light
   lightStartRadius = 2;
   lightEndRadius = 20;
   lightStartColor = "1 1 1 1";
   lightEndColor = "0 0 0 0";

   damageRadius = 6;
   radiusDamage = 100;

   impulseRadius = 6;
   impulseForce = 2000;
};


AddDamageType("spammerRocketDirect",   '<bitmap:add-ons/Weapon_Rocket_Launcher/CI_rocket> %1',    '%2 <bitmap:add-ons/Weapon_Rocket_Launcher/CI_rocket> %1',1,1);
AddDamageType("spammerRocketRadius",   '<bitmap:add-ons/Weapon_Rocket_Launcher/CI_rocketRadius> %1',    '%2 <bitmap:add-ons/Weapon_Rocket_Launcher/CI_rocketRadius> %1',1,0);
datablock ProjectileData(spammerRocketLauncherProjectile)
{
   projectileShapeName = "Add-Ons/Weapon_Rocket_Launcher/RocketProjectile.dts";
   directDamage        = 100;
   directDamageType = $DamageType::spammerRocketDirect;
   radiusDamageType = $DamageType::spammerRocketRadius;
   impactImpulse	   = 500;
   verticalImpulse	   = 500;
   explosion           = spammerRocketExplosion;
   particleEmitter     = spammerRocketTrailEmitter;

   brickExplosionRadius = 1;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 30;             
   brickExplosionMaxVolume = 30;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 60;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   sound = spammerRocketLoopSound;

   muzzleVelocity      = 200;
   velInheritFactor    = 0;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "1 0.5 0.0";

   uiName = "spammer Rocket";
};

//////////
// item //
//////////
datablock ItemData(spammerRocketLauncherItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "Add-Ons/Weapon_Rocket_Launcher/rocketlauncher.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Spammer RocketLauncher";
	iconName = "Add-Ons/Weapon_Rocket_Launcher/icon_rocketLauncher";
	doColorShift = false;
	colorShiftColor = "0.700 0.100 0.100 1.000";

	 // Dynamic properties defined by the scripts
	image = spammerRocketLauncherImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(spammerRocketLauncherImage)
{
   // Basic Item properties
   shapeFile = "Add-Ons/Weapon_Rocket_Launcher/rocketlauncher.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0 0 0";
   //eyeRotation = eulerToMatrix( "7 45 7" );
   rotation = eulerToMatrix( "0 180 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = spammerRocketLauncherProjectile;
   projectileType = Projectile;

	//casing = rocketLauncherShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   minShotTime = 0;   //minimum time allowed between shots (needed to prevent equip/dequip exploit)

   doColorShift = false;
   colorShiftColor = spammerRocketLauncherItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.1;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
   stateTransitionOnNoAmmo[1]       = "NoAmmo";
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.001;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= spammerRocketLauncherFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= tailNode;
	stateSound[2]					= spammerrocketFireSound;
   stateSequence[2]                = "Fire";
	//stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= spammerRocketLauncherSmokeEmitter;
	stateEmitterTime[3]				= 0.01;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.1;
   stateSequence[3]                = "TrigDown";
	stateTransitionOnTimeout[3]     = "CoolDown";

   stateName[5] = "CoolDown";
   stateTimeoutValue[5]            = 0.002;
	stateTransitionOnTriggerDown[5]     = "Ready";
   stateSequence[5]                = "TrigDown";

   stateName[6]   = "NoAmmo";
   stateTransitionOnAmmo[6] = "Ready";

};

function spammerRocketLauncherImage::onFire( %this, %obj )
{
   %obj.playThread(2, plant);
   %obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.client.player.getEyeVector(),"-3")));
   Parent::onFire(%this,%obj,%slot);
}

function spammerRocketLauncherProjectile::onExplode(%this, %obj, %pos)
{
   serverPlay2d(SpammerRocketDistantSound);
   parent::onExplode(%this, %obj, %pos);
}

// spearProjectile.muzzleVelocity = 100;
// //other weps
// function spearImage::onFire(%this, %obj, %slot)
// {
//    %obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.client.player.getEyeVector(),"-4")));
//    %projectile = %this.projectile;
//    %spread = 0.004;
//    %shellcount = 15;

//    for(%shell=0; %shell<%shellcount; %shell++)
//    {
//       %vector = %obj.getMuzzleVector(%slot);
//       %objectVelocity = %obj.getVelocity();
//       %vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
//       %vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
//       %velocity = VectorAdd(%vector1,%vector2);
//       %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
//       %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
//       %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
//       %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
//       %velocity = MatrixMulVector(%mat, %velocity);

//       %p = new (%this.projectileType)()
//       {
//          dataBlock = %projectile;
//          initialVelocity = %velocity;
//          initialPosition = %obj.getMuzzlePoint(%slot);
//          sourceObject = %obj;
//          sourceSlot = %slot;
//          client = %obj.client;
//       };
//       MissionCleanup.add(%p);
//    }
//    Parent::onFire(%this, %obj, %slot);
// }

// swordProjectile.directDamage        = 100;
// swordProjectile.lifetime            = 1000;
// swordProjectile.fadeDelay           = 800;
// swordProjectile.muzzleVelocity      = 200;
// swordProjectile.particleEmitter     = arrowTrailEmitter;
// swordProjectile.velInheritFactor    = 0;

// function swordImage::onFire(%this, %obj, %slot)
// {
//    %obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.client.player.getEyeVector(),"-4")));
//    %projectile = %this.projectile;
//    %spread = 0.1;
//    %shellcount = 20;

//    for(%shell=0; %shell<%shellcount; %shell++)
//    {
//       %vector = %obj.getMuzzleVector(%slot);
//       %objectVelocity = %obj.getVelocity();
//       %vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
//       %vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
//       %velocity = VectorAdd(%vector1,%vector2);
//       %x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
//       %y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
//       %z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
//       %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
//       %velocity = MatrixMulVector(%mat, %velocity);

//       %p = new (%this.projectileType)()
//       {
//          dataBlock = %projectile;
//          initialVelocity = %velocity;
//          initialPosition = %obj.getMuzzlePoint(%slot);
//          sourceObject = %obj;
//          sourceSlot = %slot;
//          client = %obj.client;
//       };
//       MissionCleanup.add(%p);
//    }
//    Parent::onFire(%this, %obj, %slot);
// }