
%error = ForceRequiredAddOn("Weapon_Rocket_Launcher");

if(%error == $Error::AddOn_Disabled)
{
   //A bit of a hack:
   //  we just forced the gun to load, but the user had it disabled
   //  so lets make it so they can't select it
   rocketLauncherItem.uiName = "";
}

//audio
datablock AudioProfile(spammerRocketFireSound)
{
   filename    = "./rocketFire.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(spammerRocketExplodeSound)
{
   filename    = "./rocket_explode.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(spammerRocketDistantSound)
{
   filename    = "./rocket_explode_distant.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(spammerRocketLoopSound)
{
   filename    = "./rocketLoop.wav";
   description = AudioCloseLooping3d;
   preload = true;
};

if(%error == $Error::AddOn_NotFound)
{
   //we don't have the gun, so we're screwed
   error("ERROR: Weapon_RocketSpammer - required add-on Weapon_Gun not found");
}
else
{
   exec("./Weapon_RocketSpammer.cs"); 
}